

#include <windows.h>
#include <winbase.h>
#include <tchar.h>

#include "serial.h"

HANDLE	g_hComm = NULL;				//


BOOL COMOpenPort(LPTSTR lpszPortName)
{
	DCB				PortDCB;
	COMMTIMEOUTS	cto;

  // Open the serial port.
	g_hComm = CreateFile (lpszPortName, // Pointer to the name of the port
	                      GENERIC_READ | GENERIC_WRITE,   // Access (read-write) mode
	                      0,            // Share mode
	                      NULL,         // Pointer to the security attribute
	                      OPEN_ALWAYS,//OPEN_EXISTING,// How to open the serial port
	                      FILE_ATTRIBUTE_NORMAL, //0,            // Port attributes
	                      NULL);        // Handle to port with attribute
	                                    // to copy

  // If it fails to open the port, return FALSE.
	if ( g_hComm == INVALID_HANDLE_VALUE ) 
		return FALSE;

	PortDCB.DCBlength = sizeof(DCB);     

  // Get the default port setting information.
	if(!GetCommState (g_hComm, &PortDCB))
		return FALSE;

  // Change the DCB structure settings.
	PortDCB.BaudRate		= CBR_115200;			// Current baud 
	PortDCB.fBinary			= TRUE;					// Binary mode; no EOF check 
	PortDCB.fParity			= TRUE;					// Enable parity checking 
	PortDCB.fOutxCtsFlow	= TRUE;					// CTS output flow control 
	PortDCB.fOutxDsrFlow	= TRUE;					// DSR output flow control 
  	PortDCB.fDtrControl		= DTR_CONTROL_ENABLE;	// DTR flow control type 
	PortDCB.fDsrSensitivity = TRUE;					// DSR sensitivity 
	PortDCB.fTXContinueOnXoff = FALSE;				// XOFF continues Tx 
	PortDCB.fOutX			= FALSE;				// No XON/XOFF out flow control 
	PortDCB.fInX			= FALSE;				// No XON/XOFF in flow control 
	PortDCB.fErrorChar		= TRUE;					// Disable error replacement 
	PortDCB.fNull			= FALSE;				// Disable null stripping 
	PortDCB.fRtsControl		= RTS_CONTROL_ENABLE;	// RTS flow control 
	PortDCB.fAbortOnError	= FALSE;				// Do not abort reads/writes on error
	PortDCB.ByteSize		= 8;					// Number of bits/byte, 4-8 
	PortDCB.Parity			= NOPARITY;				// 0-4=no,odd,even,mark,space 
	PortDCB.StopBits		= ONESTOPBIT;		    // 0,1,2 = 1, 1.5, 2 

  // Configure the port according to the specifications of the DCB 
  // structure.
	if (!SetCommState(g_hComm, &PortDCB))
	{
		return FALSE;
	}
  // Retrieve the time-out parameters for all read and write operations
  // on the port. 
	GetCommTimeouts(g_hComm, &cto);
	cto.WriteTotalTimeoutConstant 	= WRITE_TOTAL_TIMEOUT;
	cto.ReadTotalTimeoutConstant  	= READ_TOTAL_TIMEOUT;
	cto.ReadIntervalTimeout       	= READ_INTERVAL_TIMEOUT;
	cto.ReadTotalTimeoutMultiplier	= READ_TOTAL_TIMEOUT;
	SetCommTimeouts(g_hComm, &cto);

	return TRUE;
}

void COMClosePort()
{
	if(g_hComm == INVALID_HANDLE_VALUE || g_hComm == NULL) 		//߰Ă݂ĂȂꍇ͏Ȃ
		return;

	if (g_hComm)
	{
		CloseHandle(g_hComm);									//߰ĸ۰
		g_hComm = NULL;
	}
}

BOOL COMWritePort(char* lpData, long lLen)
{
	long	lWritten;
	BOOL	bRet = WriteFile(g_hComm, lpData, lLen, &lWritten, NULL);	//ްM

	if (bRet && (lLen != lWritten))				//MsorMްs̏ꍇ
		bRet = FALSE;

	return	bRet;
}

long COMReadPort(char* lpData, long lLen)
{
	long	lRead = 0;
	BOOL	bRet = ReadFile(g_hComm, lpData, lLen, &lRead, NULL);	//ްM

	return	lRead;								//Mςް
}

